=== debian/changelog ===
ott (0.34+ds-2) experimental; urgency=medium

  * Bump standards-version to 4.7.2.
  * Work on lintian reports.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 29 Oct 2025 09:38:52 +0100

ott (0.34+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 04 Jan 2025 11:17:29 +0100

ott (0.33+ds-4) unstable; urgency=medium

  * Team upload
  * Do not hardcode /usr/lib/ocaml

 -- Stéphane Glondu <glondu@debian.org>  Sat, 03 Aug 2024 14:39:22 +0200

ott (0.33+ds-3) unstable; urgency=medium

  * Add patch for Coq 8.19 support.
  * Bump standards-version to 4.7.0.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 22 Apr 2024 18:06:42 +0200
