=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

export DEB_BUILD_OPTIONS += noautodbgsym

%:
	dh $@ --with coq,ocaml

override_dh_auto_clean:
	cp src/version.ml src/version.ml.bak
	make clean
	make -C doc clean
	mv src/version.ml.bak src/version.ml
	rm -f src/.depend src/version.tex coq/.lia.cache coq/.Makefile.coq.d
	rm -f doc/README.* doc/test10.despaced.v doc/test10.lem
	find . -name "*.vo*" -delete
	find . -name "*.aux" -delete
	find . -name "Makefile.coq*" -delete
	find . -name "*.glob" -delete

override_dh_auto_build:
	make -C coq
	make -C src
	make -C doc top2.html
	help2man -N src/ott -n "A tool to write definitions of programming languages and calculi" > debian/ott.1

override_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/tmp make -C coq install
	DESTDIR=$(CURDIR)/debian/tmp make -C src install
