=== debian/tests/control ===
Test-Command: coqtop -batch -rifrom Ott ott_list
Depends: coq, libcoq-ott
